#include "Vsm.hpp"

class DSCOUNTER : public IDSIMMODEL
{
public:
	INT isdigital (CHAR *pinname);
	VOID setup (IINSTANCE *inst, IDSIMCKT *dsim);
	VOID runctrl (RUNMODES mode);
	VOID actuate (REALTIME time, ACTIVESTATE newstate);
	BOOL indicate (REALTIME time, ACTIVEDATA *data);
	VOID simulate (ABSTIME time, DSIMMODES mode);
	VOID callback (ABSTIME time, EVENTID eventid);
private:
	IINSTANCE *instance;
	IDSIMPIN *clock;
	IDSIMPIN *d0;
	IDSIMPIN *d1;
	IDSIMPIN *d2;
	IDSIMPIN *d3;
	IDSIMPIN *d4;
	IDSIMPIN *d5;
	IDSIMPIN *d6;
	IDSIMPIN *d7;

	EVENT *event;
	IDSIMCKT *ckt;

	BYTE data;
};

//Events
#define EV_TIMER 25


//Delays
#define DELAY_1s  1000000000000
#define DELAY_1ms 1000000000
#define DELAY_1us 1000000
#define DELAY_1ns 1000
#define DELAY_1ps 1
